// created on 2/20/2006 at 10:20 AM
namespace LessonPlan
{
using System;
using System.IO;
using System.Data;
using System.Collections;
using Gtk;
using Glade;

public class FormMain
{

	public Gtk.Window Form;

		//internal WeeklyPanel myWeekly;
		internal bool IsEdited = false; 
		internal static LessonData Lessons1 = new LessonData();
		internal System.Data.DataView LessonsDataview = new System.Data.DataView();
		internal System.Data.DataView ClassPlansDataview = new System.Data.DataView();
		public static LessonData.LessonsRow CurrentRow; 
		public static int CurrentRowIndex = 0; 
		public static LessonData.OptionsRow Options;
		internal ArrayList myWidgets = new ArrayList();
		internal ArrayList myCustoms = new ArrayList();
		internal Gtk.VBox CustomBox = new Gtk.VBox();
		
		internal Gtk.FileChooserDialog filedialog;
		internal Gtk.Label label_Status;
		internal Gtk.Label label_FileName;
		internal Gtk.Label label_FileSize;

		internal Gtk.Table table_Plan;
		internal Gtk.Label label_Date;
		internal System.DateTime Date = System.DateTime.Now;
		//internal FindReplace FindBar;
		
	public FormMain (Glade.XML gxml) 
	{
		this.Form = (Gtk.Window) gxml.GetWidget("window_Main"); 
		Form.Icon =  Form.RenderIcon("LP", Gtk.IconSize.Dialog, "LP");
	
		Gtk.ImageMenuItem item = (Gtk.ImageMenuItem) gxml.GetWidget("menuitem_lesson_plans1"); 
		item.Image = new Gtk.Image("Lesson", Gtk.IconSize.Menu);
		
		item = (Gtk.ImageMenuItem) gxml.GetWidget("menuitem_standards_list1"); 
		item.Image = new Gtk.Image("Gavel", Gtk.IconSize.Menu);
		
		item = (Gtk.ImageMenuItem) gxml.GetWidget("menuitem_edit_classes1"); 
		item.Image = new Gtk.Image("Apple", Gtk.IconSize.Menu);
		
		//setup table
		table_Plan = (Gtk.Table) gxml.GetWidget("table_Plan");
		
		//setup file fields
		label_Status = (Gtk.Label)gxml.GetWidget("label_Status");
		label_FileName = (Gtk.Label)gxml.GetWidget("label_FileName");
		label_FileSize = (Gtk.Label)gxml.GetWidget("label_FileSize");
		
		//setup Table
		this.ClassPlansDataview.Table = Lessons1.ClassPlans;
		this.ClassPlansDataview.Sort = "ClassPlansID";
		label_Date = (Gtk.Label)gxml.GetWidget("label_Date");

		//setup filedialog
		gxml = new Glade.XML (null, "lessonplanglade.glade", "dialog_FileChooser", null);
		filedialog = (Gtk.FileChooserDialog)gxml.GetWidget("dialog_FileChooser");
		filedialog.Icon =  Form.Icon;  //filedialog.RenderIcon("LP", Gtk.IconSize.Dialog, "LP");
		filedialog.Hide();
		gxml.Autoconnect(this);
		
		Gtk.FileFilter filter = new Gtk.FileFilter();
		filter.Name = "Lesson Plan Files";
		filter.AddPattern("*.lp1");
		filter.AddPattern("*.lps");
		filedialog.AddFilter(filter);
			
		filter = new Gtk.FileFilter();
		filter.Name = "All files";
		filter.AddPattern("*");
		filedialog.AddFilter(filter);
		
		NewFile();
	}
	public void BuildCalendar(System.DateTime myDate)
	{
	  //use Options to set whether or not a week or month is built
	bool Weekly = true;
	Date = myDate;
	Console.WriteLine("Date:" + myDate.ToLongDateString());
	uint rows = 0;
	uint columns = (uint)Lessons1.ClassPlans.Rows.Count + 1;  
		if(Weekly)
		{
			myDate = SetMonday(myDate);
			rows = 7;
			label_Date.Text = Date.ToLongDateString(); 
		}
		else
		{
			DateTime FirstofMonth = SetFirstofMonth(myDate);
			DateTime EndofMonth = FirstofMonth.AddDays(DateTime.DaysInMonth(myDate.Year, myDate.Month)-2); //i don't know why I would have thought this should be -1 not -2, but -2 works correctly.
			myDate = SetMonday(FirstofMonth);
		
			rows = (uint)(SetMonday(EndofMonth).ToOADate() + 7 - myDate.ToOADate());
			
			string[] Months = {"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"};
			label_Date.Text = Months[FirstofMonth.Month-1];
		}
	  Finish_BuildCalendar(rows, columns, myDate);
	}
		
	public void Finish_BuildCalendar(uint rows, uint columns, System.DateTime Date)
	{
		table_Plan.HideAll();
		Gtk.Container table_Container = (Gtk.Container)table_Plan;
		
		//Remove all children and resize table
		table_Container.Forall((Gtk.Callback)table_Container.Remove);
		table_Plan.Resize(rows + 1, columns);
		
		//if (Lessons1.ClassPlans.Rows.Count != 0)
			
		//build dates on left
		for(uint r=0; r< rows; r++)
		{
			System.DateTime currentDate =  DateTime.FromOADate(Date.ToOADate() +r);
			Gtk.EventBox eventbox_day = new Gtk.EventBox();
			Gtk.VBox box_day = new Gtk.VBox(); //change to hbox
			eventbox_day.Add(box_day);
						
			Gtk.Label label_Dayofweek= new Gtk.Label(currentDate.ToShortDateString()); 
			//dayofweek.Angle = 90;
			box_day.Add(label_Dayofweek);
			
			Gtk.Label label_Day = new Gtk.Label(currentDate.DayOfWeek.ToString());
			//dayofweek.Angle = 90;
			box_day.Add(label_Day);
			
			Gtk.Label label_DayComment= new Gtk.Label("");
			//dayofweek.Angle = 90;
			box_day.Add(label_DayComment);
						
			table_Plan.Attach(eventbox_day, 0, 1, r + 1, r + 2, Gtk.AttachOptions.Fill, Gtk.AttachOptions.Fill, 0, 0);	
		}
		
		//add classes
		//Create Group Boxes
		Console.WriteLine("Classes Count:" + this.ClassPlansDataview.Count);
			for(uint n = 0; n < this.ClassPlansDataview.Count; n++)
			{
				if (!(this.ClassPlansDataview[(int)n]==null))
				{
					//AddClass
					if(Options.ClassesOnTop)
					{
						EventBoxEx ClassEvent = new EventBoxEx(this.ClassPlansDataview[(int)n].Row);
						ClassEvent.Name = Lessons1.ClassPlans.ClassNamesColumn.ColumnName;
						Gtk.Label lbClass = new Gtk.Label();
						lbClass.WidthRequest = 150;// + r * 25 / this.ClassPlansDataview.Count;
						lbClass.HeightRequest = 20;
						if (this.ClassPlansDataview[(int)n].Row.IsNull(Lessons1.ClassPlans.ClassNamesColumn.ColumnName) == false)
						{
							lbClass.Text = this.ClassPlansDataview[(int)n].Row[Lessons1.ClassPlans.ClassNamesColumn.ColumnName].ToString(); //Class Name
							Modules.SetLabelSize(lbClass, "large");
						}
						ClassEvent.ButtonReleaseEvent += new Gtk.ButtonReleaseEventHandler(EditLabel); 
						ClassEvent.Add(lbClass);

						Gtk.VBox ClassVBox = new Gtk.VBox();
						///textV.TextViewPlus WeeklyComment = new textV.TextViewPlus();

						ClassVBox.Add(ClassEvent);
						//ClassVBox.Add(WeeklyComment);
						//ClassVBox.SetChildPacking(ClassEvent, false, false, 0, Gtk.PackType.Start);
						table_Plan.Attach(ClassVBox, n + 1, n + 2, 0, 1, Gtk.AttachOptions.Fill, Gtk.AttachOptions.Fill, 0, 0);	

					}
					else
					{
						//VerticalText label_Class = new VerticalText();
						//label_Class.WidthRequest = 27;
						//label_Class.HeightRequest = 150;
						//if (this.ClassPlansDataview[r].Row.IsNull(MainForm.Lessons1.ClassPlans.ClassNamesColumn.ColumnName) == false)
						//{
						//	label_Class.Name = this.ClassPlansDataview[r].Row[MainForm.Lessons1.ClassPlans.ClassNamesColumn.ColumnName].ToString(); //Class Name
						//	label_Class.setText((LessonData.ClassPlansRow)this.ClassPlansDataview[r].Row);  
						//}
						//table_Plan.Attach(label_Class, 0, 1, r + 1, r + 2, Gtk.AttachOptions.Fill, Gtk.AttachOptions.Fill, 0, 0);	

					}
				
					//Add Plans
					for (uint r = 0; r < rows; r++)
					{
					Console.WriteLine("R:" + r);
						textV.TextViewPlus DayPlan = new textV.TextViewPlus();
						DayPlan.WidthRequest = 150;
						DayPlan.HeightRequest = 50;
						DayPlan.TextView.Name = "Day" + n.ToString();
						//DayPlan.TextView.ParentRow = (LessonData.ClassPlansRow)this.ClassPlansDataview[n].Row;
						table_Plan.Attach(DayPlan, n + 1, n + 2, r + 1, r + 2, Gtk.AttachOptions.Fill|Gtk.AttachOptions.Expand , Gtk.AttachOptions.Fill|Gtk.AttachOptions.Expand , 0, 0);	

					//	Modules.DoEvents();
					}
					
				}
			}
		
		table_Plan.ShowAll();
	}
	public DateTime SetMonday(DateTime myDate)
	{
		if (Convert.ToInt32(myDate.DayOfWeek) != 1)
		{
			return DateTime.FromOADate(myDate.ToOADate() - (Convert.ToDouble(myDate.DayOfWeek) -1)); 
		}
		return myDate;
	}
	
	public DateTime SetFirstofMonth(DateTime myDate)
	{
		return new System.DateTime(myDate.Year, myDate.Month, 1);
	}
	
	private void EditLabel(object sender, Gtk.ButtonReleaseEventArgs e)
	{
		if (e.Event.Button == 1)
		{
		   EditLabel(sender);
		}
	}
	private void EditLabel(object sender)
		{
				//Allow the label to be changed
				EventBoxEx ClassEvent = (EventBoxEx)sender;
				Gtk.Label lbClass = (Gtk.Label)ClassEvent.Children[0];
			
				EntryEx EntryClass = new EntryEx();
				//lbClass.Colormap = Gtk.Label.DefaultColormap;
				//lbClass.ModifyBase(Gtk.StateType.Normal, Gtk.Label.DefaultStyle.Background(Gtk.StateType.Normal));  
				EntryClass.Name = ClassEvent.Name;
				EntryClass.WidthRequest = lbClass.WidthRequest;
				EntryClass.HeightRequest = lbClass.HeightRequest;
				EntryClass.FocusOutEvent += new Gtk.FocusOutEventHandler(EndEditLabel);
				EntryClass.SetValue(ClassEvent.myRow);
				lbClass.Destroy();
				ClassEvent.Add(EntryClass);
				EntryClass.Show();
				EntryClass.GrabFocus();
		}
		private void EndEditLabel(object sender, Gtk.FocusOutEventArgs e)
		{
			//Fix the changes and save them to the dataset
			EntryEx EntryClass = (EntryEx)sender;
			EventBoxEx ClassEvent = (EventBoxEx)EntryClass.Parent;

			Gtk.Label lbClass = new Gtk.Label();
			lbClass.WidthRequest = EntryClass.WidthRequest;// + r * 25 / this.ClassPlansDataview.Count;
			lbClass.HeightRequest = EntryClass.HeightRequest;
			lbClass.Text = EntryClass.Text;
			EntryClass.Destroy();
			ClassEvent.Add(lbClass);
			if (ClassEvent.Name == Lessons1.Days.DescriptionColumn.ColumnName)
					Modules.SetLabelBlue(lbClass, "large");
			else
					Modules.SetLabelSize(lbClass, "large");
			lbClass.Show();
			lbClass.GrabFocus();
		}


	private void NewFile()
		{
			Lessons1.Clear();
			//Gtk.TreeStore myStore = (Gtk.TreeStore)this.LessonTreeView.List.Model;
			//if (!(myStore == null))
			//myStore.Clear();

			AddOptions();
			Options = Lessons1.Options[0];
			//Add NewRecord
			label_FileName.Text = "";
			SetStatusBar();
			//BtnNewRecord_Clicked(this, new System.EventArgs());
			IsEdited = false;
			BuildCalendar(Date);
		}
		private void AddOptions()
		{
			if (Lessons1.Options.Rows.Count > 0)
			{
			  //AddDefaultFields((LessonData.OptionsRow)Lessons1.Options.Rows[0]);
			}
			else
			{
				LessonData.OptionsRow OptionsRow = Lessons1.Options.NewOptionsRow();
				Lessons1.Options.AddOptionsRow(OptionsRow);
				//AddDefaultFields(OptionsRow);
			}
		}

	// Connect the Signals defined in Glade
	private void on_window_Main_delete_event (object sender, DeleteEventArgs a) 
	{
		Application.Quit ();
		a.RetVal = true;
	}
	

	//Main Menu
	private void on_new1_activate(object sender, System.EventArgs a)
	{
	
	}
	
	private void on_open1_activate(object sender, System.EventArgs a)
	{
		if(filedialog.Run() == (int)Gtk.ResponseType.Ok)
		{
			filedialog.Hide();
			OpenFile(filedialog.Filename);
		} 
		filedialog.Hide();
	}
	
	private void OpenFile(string OrigFileName)
		{
			if (File.Exists(OrigFileName) == true) 
			{
				if (this.label_FileName.Text != "" & this.label_FileName.Text != OrigFileName) 
				{
					//if (CloseFile(FileName) == false) 
					//{
					//	return;
					//}
				}
				this.label_Status.Text = "Opening..." + OrigFileName;
				this.label_FileName.Text = OrigFileName;
				string BackupFileName = OrigFileName.Replace(".lp1", DateTime.Now.ToShortDateString().Replace("/", "_") + "_" + "backup" + ".xml");
				if (System.IO.File.Exists(BackupFileName)) 
				{
					System.IO.File.SetAttributes(BackupFileName, FileAttributes.Normal);
				}
				
				StreamReader file1 = new StreamReader(this.label_FileName.Text);
				StreamWriter file2 = new StreamWriter(BackupFileName);
				file2.Write(file1.ReadToEnd());
				file2.Close();
				file1.Close();
				string Version = "0";
				DataSet LoadDataset = new DataSet();
				try 
				{
					LoadDataset.ReadXml(OrigFileName, XmlReadMode.Auto);
					DataRow AboutRow = LoadDataset.Tables["About"].Rows[0];
					if (!(AboutRow == null)) 
					{
						if (AboutRow.IsNull("ProductVersion") == false) 
						{
							Version = AboutRow["ProductVersion"].ToString();
						}
					}
				} 
				catch(Exception e)
				{
					System.Console.WriteLine(e.Message);
				}
				Lessons1.Clear();
				if (Version == "0") 
				{
					//TODO: Add import for really old versions
					//					ImportOLDFormats ImportForm = new ImportOLDFormats();
					//					ImportForm.Owner = this;
					//					ImportForm.Version = Version;
					//					ImportForm.ReadFileName = BackupFileName;
					//					ImportForm.ShowDialog();
				} 
				else if (Version == "101.4.1.0" || Version == "101.4.1.1") 
				{
					System.IO.FileStream myFileStream = new System.IO.FileStream(BackupFileName, System.IO.FileMode.Open);
					System.Xml.XmlTextReader myXmlReader = new System.Xml.XmlTextReader(myFileStream);
					try 
					{

							Lessons1.Lessons.Columns.Add("Purpose");
							Lessons1.Lessons.Columns.Add("Unit Name");
							Lessons1.Lessons.Columns.Add("Unit Number");
							Lessons1.Lessons.Columns.Add("Time");
							Lessons1.Lessons.Columns.Add("Description");
							Lessons1.Lessons.Columns.Add("Introduction");
    						Lessons1.Lessons.Columns.Add("Lesson");
							Lessons1.Lessons.Columns.Add("Wrap Up");
							Lessons1.Lessons.Columns.Add("Assessment Plan");

						Lessons1.ReadXml(myXmlReader, XmlReadMode.Auto);

						for (int r = 0; r < Lessons1.Lessons.Rows.Count; r++)
						{
							LessonData.LessonsRow myRow = (LessonData.LessonsRow)Lessons1.Lessons.Rows[r];
							if (myRow.IsNull("Purpose")== false && !(myRow["Purpose"].ToString() ==""))
							{
								//AddCustomRow(myRow, "Purpose", myRow["Purpose"].ToString());
							}
							if (myRow.IsNull("Unit Name")== false && !(myRow["Unit Name"].ToString() ==""))
							{
								myRow.Section = myRow["Unit Name"].ToString();
							}
							if (myRow.IsNull("Unit Number")== false && !(myRow["Unit Number"].ToString() ==""))
							{
								myRow.Unit = myRow["Unit Number"].ToString();
							}
							if (myRow.IsNull("Time")== false && !(myRow["Time"].ToString() ==""))
							{
								myRow.Length = myRow["Time"].ToString();
							}
							if (myRow.IsNull("Description")== false && !(myRow["Description"].ToString() ==""))
							{
								//AddCustomRow(myRow, "Abstract", myRow["Abstract"].ToString());
							}
							if (myRow.IsNull("Introduction")== false && !(myRow["Introduction"].ToString() ==""))
							{
								//AddCustomRow(myRow, "Introduction", myRow["Introduction"].ToString());
							}
							if (myRow.IsNull("Lesson")== false && !(myRow["Lesson"].ToString() ==""))
							{
								//AddCustomRow(myRow, "Lesson", myRow["Lesson"].ToString());
							}
							if (myRow.IsNull("Wrap Up")== false && !(myRow["Wrap Up"].ToString() ==""))
							{
								//AddCustomRow(myRow, "Wrap Up", myRow["Wrap Up"].ToString());
							}
							if (myRow.IsNull("Assessment Plan")== false && !(myRow["Assessment Plan"].ToString() ==""))
							{
								//AddCustomRow(myRow, "Assessment Plan", myRow["Assessment Plan"].ToString());
							}
						}
					} 
					catch (Exception ex) 
					{
						Console.WriteLine(ex.Message);
					} 
					finally 
					{
						Lessons1.Lessons.Columns.Remove("Purpose");
						Lessons1.Lessons.Columns.Remove("Unit Name");
						Lessons1.Lessons.Columns.Remove("Unit Number");
						Lessons1.Lessons.Columns.Remove("Time");				
						Lessons1.Lessons.Columns.Remove("Description");
						Lessons1.Lessons.Columns.Remove("Introduction");
						Lessons1.Lessons.Columns.Remove("Lesson");
						Lessons1.Lessons.Columns.Remove("Wrap Up");
						Lessons1.Lessons.Columns.Remove("Assessment Plan");

						//AddOptions();

						myXmlReader.Close();
					}
				}
				else
				{
					System.IO.FileStream myFileStream = new System.IO.FileStream(BackupFileName, System.IO.FileMode.Open);
					System.Xml.XmlTextReader myXmlReader = new System.Xml.XmlTextReader(myFileStream);
					try 
					{
						Lessons1.ReadXml(myXmlReader, XmlReadMode.Auto);  //Needed
					} 
					catch (Exception ex) 
					{
						Console.WriteLine(ex.Message);
					} 
					finally 
					{
						myXmlReader.Close();
					}

				}

				//Options = Lessons1.Options[0];
				SetStatusBar();
				this.label_Status.Text = "";
				//TODO: FillTreeByOrder();
				//this.myWeekly.CreateWeeklyPage();
				//this.LessonTreeView.FillList(null, Lessons1.Lessons.Class_NameColumn.ColumnName, false);
				//this.PositionChanged(this, 0);
				BuildCalendar(Date);
				IsEdited = false;
			}
		}
	
			private void SetStatusBar()
		{
			if (File.Exists(this.label_FileName.Text)) 
			{
				FileInfo fi = new FileInfo(this.label_FileName.Text);
				string FileName = System.IO.Path.GetFileName(this.label_FileName.Text);	
				this.label_FileSize.Text = "Size: " + Convert.ToInt32(fi.Length / 1000) + "kb";
				Form.Title = FileName + " - Lesson Plan 101";
			} 
			else 
			{
				this.label_FileName.Text = "File NOT Saved!";
				this.label_FileSize.Text = "";
				Form.Title = "Lesson Plan 101";
			}
			//Modules.DoEvents();
		}
		private void on_save1_activate(object sender, System.EventArgs a)
	{
	
	}
	
		private void on_save_as1_activate(object sender, System.EventArgs a)
	{
	
	}
	
		private void on_close1_activate(object sender, System.EventArgs a)
	{
	
	}
	
		private void on_export1_activate(object sender, System.EventArgs a)
	{
	
	}
	
		private void on_print_preview1_activate(object sender, System.EventArgs a)
	{
	
	}
	
		private void on_print1_activate(object sender, System.EventArgs a)
	{
	
	}
	
		private void on_quit1_activate(object sender, System.EventArgs a)
	{
	
	}
	
	//Edit Menu
			private void on_undo1_activate(object sender, System.EventArgs a)
	{
	
	}
	
			private void on_redo1_activate(object sender, System.EventArgs a)
	{
	
	}
	
			private void on_cut1_activate(object sender, System.EventArgs a)
	{
	
	}
	
			private void on_copy1_activate(object sender, System.EventArgs a)
	{
	
	}
	
			private void on_paste1_activate(object sender, System.EventArgs a)
	{
	
	}
	
			private void on_delete1_activate(object sender, System.EventArgs a)
	{
	
	}
	
			private void on_select_all1_activate(object sender, System.EventArgs a)
	{
	
	}
	
	//View
			private void on_weekly_plans1_activate(object sender, System.EventArgs a)
	{
	
	}
	
	private void on_lesson_plans1_activate(object sender, System.EventArgs a)
	{
		Glade.XML gxml = new Glade.XML (null, "lessonplanglade.glade", "window_Plan", null);
		FormPlan newForm = new FormPlan(gxml);
		gxml.Autoconnect (newForm);
	}
	
	private void on_standards_list1_activate(object sender, System.EventArgs a)
	{
		Glade.XML gxml = new Glade.XML (null, "lessonplanglade.glade", "dialog_Standards", null);
		DialogStandards newForm = new DialogStandards(gxml);
		gxml.Autoconnect (newForm);
	}
	
	private void on_calendar1_day_selected_double_click(object sender, System.EventArgs a)
	{
		
		
	}
	
	
	//Search
			private void on_find1_activate(object sender, System.EventArgs a)
	{
	
	}
	
			private void on_search_database1_activate(object sender, System.EventArgs a)
	{
	
	}
	
			private void on_use_filter1_activate(object sender, System.EventArgs a)
	{
	
	}
	
	//Navigate Menu
	private void on_forward1_activate(object sender, System.EventArgs a)
	{
		//use Options to set whether or not a week or month is built
		bool Weekly = true;
		if(Weekly)
		{
			BuildCalendar(System.DateTime.FromOADate(Date.ToOADate() + 7));
		}
		else
		{
			BuildCalendar(System.DateTime.FromOADate(Date.ToOADate() + System.DateTime.DaysInMonth(Date.Year, Date.Month))); 
		}
	}
	
	private void on_back1_activate(object sender, System.EventArgs a)
	{
		//use Options to set whether or not a week or month is built
		bool Weekly = true;
		if(Weekly)
		{
			BuildCalendar(System.DateTime.FromOADate(Date.ToOADate() - 7));
		}
		else
		{
			BuildCalendar(System.DateTime.FromOADate(Date.ToOADate() - System.DateTime.DaysInMonth(Date.Year, Date.Month))); 
		}
	}
	
	private void on_choose_date1_activate(object sender, System.EventArgs a)
	{
	}
	
	//Tools
			private void on_edit_classes1_activate(object sender, System.EventArgs a)
	{
	
	}
	
			private void on_preferences1_activate(object sender, System.EventArgs a)
	{
	
	}
	
	//Help
			private void on_about1_activate(object sender, System.EventArgs a)
	{
			Glade.XML gxml = new Glade.XML (null, "lessonplanglade.glade", "dialog_About", null);
			gxml.Autoconnect(this);
			
	}
}

}