#include <gtk/gtk.h>
#include <sqlite3.h>
#include <xhtmlite/xhtmlite_module/xhtmlcallbacks.h>
#include <xhtmlite/xhtmlite_module/xhtmlinterface.h>
#include <xhtmlite/xhtmlite_module/xhtmlbuffer.h>


void
lp_setup_weekly (GtkWidget * lp_window_main, sqlite3 * db)
{
  GtkWidget *table_Plan = lookup_widget (lp_window_main, "table_Plan");

  //rebuild table
  gtk_container_foreach (GTK_CONTAINER (table_Plan),
			 (GtkCallback) gtk_widget_destroy, NULL);

  gboolean dates_on_top = TRUE;
  gboolean show_Saturday = TRUE;
  gboolean show_Sunday = TRUE;

  int class_count = 0;		//get classes count
  int days_count = 7;		//days count

/*   gchar *sql_statement;		// = g_strdup("");
  sqlite3_stmt *pStmt = 0;
  char *zErrMsg = 0;
  int rc = SQLITE_OK;

const char *zLeftover;
  if (db != NULL)
    {
      sql_statement = g_strdup ("SELECT * FROM 'class' WHERE *");
	//rc = sqlite3_prepare(db, sql_statement, -1, &pStmt, &zErrMsg);
    //  int sqlite_response;
	//class_count = sqlite3_data_count(pStmt);
	//printf("class_count:%d\n", class_count);
	//char *class_column = sqlite3_column_name(pStmt, 1);
	//printf("class_column:%s\n", class_column);
	rc = sqlite3_exec (db, sql_statement, lessonplan_sqlite3_callback, 0, &zErrMsg);
      if (rc != SQLITE_OK)
		{
	  	fprintf (stderr, "SQL error: %s\n", zErrMsg);
	  	sqlite3_free (zErrMsg);
		}
    } */

  GtkWidget *lp_main_label_date =
    lookup_widget (lp_window_main, "lp_main_label_date");
  GDate *mydate = g_object_get_data (G_OBJECT (lp_main_label_date), "date");
  GDate *setdate = g_date_new_dmy (g_date_get_day (mydate),
				   g_date_get_month (mydate),
				   g_date_get_year (mydate));

  if (dates_on_top)		//setup the days on the top
    {
      gtk_table_resize (GTK_TABLE (table_Plan), class_count + 1,
			days_count + 1);
    }
  else				//setup the days on the left
    {
      gtk_table_resize (GTK_TABLE (table_Plan), days_count + 1,
			class_count + 1);
    }

  //setup dates
  int d = 0;
  gchar mydate_string[101];
  gchar myday_of_week[101];
  while (d < days_count)
    {
      g_date_strftime (mydate_string, 100, "%Y/%m/%d\0", setdate);
      g_date_strftime (myday_of_week, 100, "%A\0", setdate);
      printf ("current date:%s\n", mydate_string);
      GtkWidget *eventbox_day = gtk_event_box_new ();
      GtkWidget *box_day;
      GtkWidget *label_day_of_week = gtk_label_new (myday_of_week);
      GtkWidget *label_day = gtk_label_new (mydate_string);
      GtkWidget *label_day_description = gtk_label_new ("test_string");

      if (dates_on_top)
	{
	  box_day = gtk_vbox_new (TRUE, 1);
	  gtk_table_attach (GTK_TABLE (table_Plan),
			    eventbox_day,
			    d + 1, d + 2,
			    0, 1, GTK_EXPAND || GTK_FILL, GTK_SHRINK, 1, 1);
	}
      else
	{
	  box_day = gtk_hbox_new (TRUE, 1);
	  gtk_label_set_angle (GTK_LABEL (label_day_of_week), 90);
	  gtk_label_set_angle (GTK_LABEL (label_day), 90);
	  gtk_label_set_angle (GTK_LABEL (label_day_description), 90);
	  gtk_table_attach (GTK_TABLE (table_Plan),
			    eventbox_day,
			    0, 1,
			    d + 1, d + 2,
			    GTK_SHRINK, GTK_EXPAND || GTK_FILL, 1, 1);
	}

      gtk_container_add (GTK_CONTAINER (eventbox_day), box_day);
      gtk_container_add (GTK_CONTAINER (box_day), label_day_of_week);
      gtk_container_add (GTK_CONTAINER (box_day), label_day);
      gtk_container_add (GTK_CONTAINER (box_day), label_day_description);
      gtk_widget_show_all (eventbox_day);
      d += 1;
      g_date_add_days (setdate, 1);
    }

//setup class names
  int c = 0;
  while (c < class_count)
    {
      GtkWidget *eventbox_class = gtk_event_box_new ();
      GtkWidget *box_class;
      GtkWidget *label_class_name = gtk_label_new ("test class");

      if (dates_on_top)
	{
	  box_class = gtk_hbox_new (TRUE, 1);
	  gtk_label_set_angle (GTK_LABEL (label_class_name), 90);
	  gtk_table_attach (GTK_TABLE (table_Plan),
			    eventbox_class,
			    0, 1,
			    c + 1, c + 2,
			    GTK_SHRINK, GTK_EXPAND || GTK_FILL, 1, 1);
	}
      else
	{
	  box_class = gtk_vbox_new (TRUE, 1);
	  gtk_table_attach (GTK_TABLE (table_Plan),
			    eventbox_class,
			    c + 1, c + 2,
			    0, 1, GTK_EXPAND || GTK_FILL, GTK_SHRINK, 1, 1);
	}

      gtk_container_add (GTK_CONTAINER (eventbox_class), box_class);
      gtk_container_add (GTK_CONTAINER (box_class), label_class_name);
      gtk_widget_show_all (eventbox_class);
      c += 1;
    }


  //fillin day plans
  c = 0;
  while (c < class_count)
    {
      d = 0;
      while (d < days_count)
	{
	  GtkTextView *textview = gtk_text_view_new ();
	  GtkTextBuffer *textbuffer =
	    xhtmlite_create_buffer (textview, FALSE);
	  set_XHTML (textbuffer, "<html>Yeah I am going biking</html>");
	  GtkWidget *scrolled_window = gtk_scrolled_window_new (NULL, NULL);
	  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW
					  (scrolled_window),
					  GTK_POLICY_AUTOMATIC,
					  GTK_POLICY_AUTOMATIC);
	  gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW
						 (scrolled_window),
						 GTK_WIDGET (textview));

	  if (dates_on_top)
	    {
	      gtk_table_attach_defaults (GTK_TABLE (table_Plan),
					 GTK_WIDGET (scrolled_window),
					 d + 1, d + 2, c + 1, c + 2);
	    }
	  else
	    {
	      gtk_table_attach_defaults (GTK_TABLE (table_Plan),
					 GTK_WIDGET (scrolled_window),
					 c + 1, c + 2, d + 1, d + 2);
	    }
	  gtk_widget_show_all (GTK_WIDGET (scrolled_window));
	  d += 1;
	}
      c += 1;
    }
}
